Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 495)
@@ -1826,11 +1971,12 @@
               {
                   m_cache_directory.inval( way, set );
-                  r_config_nlines  = r_config_nlines.read() - 1;
-                  r_config_address = r_config_address.read() + (m_words<<2);
-                  r_config_fsm     = CONFIG_LOOP;
-
-#if DEBUG_MEMC_CONFIG
-if(m_debug)
-std::cout << "  <MEMC " << name() << " CONFIG_DIR_IVT_LOCK>"
+                  r_config_cmd_lines  = r_config_cmd_lines.read() - 1;
+                  r_config_rsp_lines  = r_config_rsp_lines.read() - 1;
+                  r_config_address    = r_config_address.read() + (m_words<<2);
+                  r_config_fsm        = CONFIG_LOOP;
+
+ #if DEBUG_MEMC_CONFIG
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CONFIG_IVT_LOCK>"
           << " No copies in L1 : inval DIR entry"  << std::endl;
 #endif
@@ -1863,9 +2009,9 @@
                       r_config_ivt_index = index;
                       if ( broadcast )  r_config_fsm = CONFIG_BC_SEND;
-                      else              r_config_fsm = CONFIG_INV_SEND;
+                      else              r_config_fsm = CONFIG_INVAL_SEND;
 
 #if DEBUG_MEMC_CONFIG
 if(m_debug)
-std::cout << "  <MEMC " << name() << " CONFIG_DIR_IVT_LOCK>"
+std::cout << "  <MEMC " << name() << " CONFIG_IVT_LOCK>"
           << " Inval DIR entry and register inval in IVT"
           << " : index = " << std::dec << index
@@ -1879,5 +2025,5 @@
 #if DEBUG_MEMC_CONFIG
 if(m_debug)
-std::cout << "  <MEMC " << name() << " CONFIG_DIR_IVT_LOCK>"
+std::cout << "  <MEMC " << name() << " CONFIG_IVT_LOCK>"
           << " IVT full : release DIR & IVT locks and retry" << std::endl;
 #endif
@@ -1893,10 +2039,14 @@
               not r_config_to_cc_send_brdcast_req.read() )
           {
+              // post bc inval request
               r_config_to_cc_send_multi_req   = false;
               r_config_to_cc_send_brdcast_req = true;
               r_config_to_cc_send_trdid       = r_config_ivt_index.read();
               r_config_to_cc_send_nline       = m_nline[(addr_t)(r_config_address.read())];
-              r_cleanup_to_config_ack         = false;
-              r_config_fsm                    = CONFIG_BC_WAIT;
+
+              // prepare next iteration
+              r_config_cmd_lines              = r_config_cmd_lines.read() - 1;
+              r_config_address                = r_config_address.read() + (m_words<<2);
+              r_config_fsm                    = CONFIG_LOOP;
 
 #if DEBUG_MEMC_CONFIG
@@ -1909,24 +2059,6 @@
           break;
       }
-      ////////////////////
-      case CONFIG_BC_WAIT:      // wait broadcast completion to return to LOOP
-      {
-          if ( r_cleanup_to_config_ack.read() ) 
-          {
-              r_config_fsm     = CONFIG_LOOP;
-              r_config_nlines  = r_config_nlines.read() - 1;
-              r_config_address = r_config_address.read() + (m_words<<2);
-          }
-
-#if DEBUG_MEMC_CONFIG
-if(m_debug)
-std::cout << "  <MEMC " << name() << " CONFIG_BC_WAIT> Waiting BC completion " 
-          << " done = " << r_cleanup_to_config_ack.read() 
-          << std::endl; 
-#endif
-          break;
-      }
-      /////////////////////
-      case CONFIG_INV_SEND:    // Post a multi inval request to CC_SEND FSM
+      ///////////////////////
+      case CONFIG_INVAL_SEND:    // Post a multi inval request to CC_SEND FSM
       {
           if( not r_config_to_cc_send_multi_req.read() and 
@@ -1937,16 +2069,25 @@
               r_config_to_cc_send_trdid       = r_config_ivt_index.read();
               r_config_to_cc_send_nline       = m_nline[(addr_t)(r_config_address.read())];
-              r_multi_ack_to_config_ack       = false;
-
+
+              // post data into FIFO
               config_to_cc_send_fifo_srcid    = r_config_dir_copy_srcid.read();
               config_to_cc_send_fifo_inst     = r_config_dir_copy_inst.read();
               config_to_cc_send_fifo_put      = true;
 
-              if ( r_config_dir_count.read() == 1 )  r_config_fsm = CONFIG_INV_WAIT;
-              else                                   r_config_fsm = CONFIG_HEAP_REQ;
-
+              if ( r_config_dir_count.read() == 1 )  // one copy
+              {
+                  // prepare next iteration
+                  r_config_cmd_lines          = r_config_cmd_lines.read() - 1;
+                  r_config_address            = r_config_address.read() + (m_words<<2);
+                  r_config_fsm                = CONFIG_LOOP;
+              }
+              else                                   // several copies
+              {
+                  r_config_fsm = CONFIG_HEAP_REQ;
+              }
+ 
 #if DEBUG_MEMC_CONFIG
 if(m_debug)
-std::cout << "  <MEMC " << name() << " CONFIG_INV_SEND>"
+std::cout << "  <MEMC " << name() << " CONFIG_INVAL_SEND>"
           << " Post multi inval request to CC_SEND FSM" 
           << " / address = " << std::hex << r_config_address.read() 
@@ -1963,5 +2104,5 @@
           {
               r_config_fsm       = CONFIG_HEAP_SCAN;
-              r_config_heap_next = r_config_dir_next_ptr.read();
+              r_config_heap_next = r_config_dir_ptr.read();
           }
 
@@ -2010,5 +2151,5 @@
           if ( m_heap.is_full() )
           {
-              last_entry.next = r_config_dir_next_ptr.read();
+              last_entry.next = r_config_dir_ptr.read();
               m_heap.unset_full();
           }
@@ -2018,7 +2159,11 @@
           }
 
-          m_heap.write_free_ptr( r_config_dir_next_ptr.read() );
+          m_heap.write_free_ptr( r_config_dir_ptr.read() );
           m_heap.write( r_config_heap_next.read(), last_entry );
-          r_config_fsm = CONFIG_INV_WAIT;
+
+          // prepare next iteration
+          r_config_cmd_lines          = r_config_cmd_lines.read() - 1;
+          r_config_address            = r_config_address.read() + (m_words<<2);
+          r_config_fsm                = CONFIG_LOOP;
 
 #if DEBUG_MEMC_CONFIG
@@ -2028,45 +2173,4 @@
 #endif
           break;
-      }
-      /////////////////////
-      case CONFIG_INV_WAIT:      // wait inval completion to return to LOOP
-      {
-          if ( r_multi_ack_to_config_ack.read() )
-          {
-              r_config_fsm     = CONFIG_LOOP;
-              r_config_nlines  = r_config_nlines.read() - 1;
-              r_config_address = r_config_address.read() + (m_words<<2);
-          }
-
-#if DEBUG_MEMC_CONFIG
-if(m_debug)
-std::cout << "  <MEMC " << name() << " CONFIG_INV_WAIT> Waiting inval completion " 
-          << " done = " << r_multi_ack_to_config_ack.read() 
-          << std::endl; 
-#endif
-          break;
-      }
-
-      ////////////////
-      case CONFIG_RSP:  // request TGT_RSP FSM to return response 
-      {
-          if ( not r_config_to_tgt_rsp_req.read() )
-          {
-              r_config_to_tgt_rsp_srcid  = r_config_srcid.read();
-              r_config_to_tgt_rsp_trdid  = r_config_trdid.read();
-              r_config_to_tgt_rsp_pktid  = r_config_pktid.read();
-              r_config_to_tgt_rsp_error  = false;
-              r_config_to_tgt_rsp_req    = true;
-              r_config_fsm               = CONFIG_IDLE;
-
-#if DEBUG_MEMC_CONFIG
-if(m_debug)
-std::cout << "  <MEMC " << name() << " CONFIG_RSP> Request TGT_RSP FSM to return response:"
-          << " error = " << r_config_to_tgt_rsp_error.read()
-          << " / rsrcid = " << std::hex << r_config_srcid.read() << std::endl;
-#endif
-          }
-          break;
-
       }
   }  // end switch r_config_fsm
@@ -2122,9 +2226,9 @@
     case READ_DIR_REQ:  // Get the lock to the directory
     {
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_READ)
-      {
-        r_read_fsm = READ_DIR_LOCK;
-        m_cpt_read_fsm_n_dir_lock++;
-      }
+        if(r_alloc_dir_fsm.read() == ALLOC_DIR_READ)
+        {
+          r_read_fsm = READ_DIR_LOCK;
+          m_cpt_read_fsm_n_dir_lock++;
+    }
 
 #if DEBUG_MEMC_READ
@@ -2141,9 +2245,10 @@
     case READ_DIR_LOCK:  // check directory for hit / miss
     {
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_READ)
-      {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_READ) and
+        "MEMC ERROR in READ_DIR_LOCK state: Bad DIR allocation");
+
         size_t way = 0;
         DirectoryEntry entry =
-          m_cache_directory.read(m_cmd_read_addr_fifo.read(), way);
+        m_cache_directory.read(m_cmd_read_addr_fifo.read(), way);
         if(((m_cmd_read_pktid_fifo.read() & 0x7) == TYPE_LL) and not r_read_ll_done.read())   // access the global table ONLY when we have an LL cmd
         {
@@ -2164,7 +2269,4 @@
         r_read_copy       = entry.owner.srcid;
 
-#if L1_MULTI_CACHE
-        r_read_copy_cache = entry.owner.cache_id;
-#endif
         r_read_copy_inst  = entry.owner.inst;
         r_read_ptr        = entry.ptr; // pointer to the heap
@@ -2216,11 +2318,4 @@
 }
 #endif
-      }
-      else
-      {
-        std::cout << "VCI_MEM_CACHE ERROR " << name() << " READ_DIR_LOCK state"
-                  << "Bad DIR allocation"   << std::endl;
-        exit(0);
-      }
       break;
     }
@@ -2318,6 +2413,6 @@
 
     {
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_READ)
-      {
+         assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_READ) and
+        "MEMC ERROR in READ_DIR_HIT state: Bad DIR allocation");
         // check if this is an instruction read, this means pktid is either
         // TYPE_READ_INS_UNC   0bX010 with TSAR encoding
@@ -2335,6 +2430,4 @@
 
         m_cache_data.read_line(way, set, r_read_data);
-
-        if(m_monitor_ok) check_monitor( m_cmd_read_addr_fifo.read(), r_read_data[0], true);
 
         // update the cache directory
@@ -2353,7 +2446,4 @@
           {
             entry.owner.srcid    = m_cmd_read_srcid_fifo.read();
-#if L1_MULTI_CACHE
-            entry.owner.cache_id = m_cmd_read_pktid_fifo.read();
-#endif
             entry.owner.inst     = inst_read;
             entry.count          = r_read_count.read() + 1;
@@ -2362,7 +2452,4 @@
           {
             entry.owner.srcid    = 0;
-#if L1_MULTI_CACHE
-            entry.owner.cache_id = 0;
-#endif
             entry.owner.inst     = false;
             entry.count          = r_read_count.read() + 1;
@@ -2372,7 +2459,4 @@
         {
           entry.owner.srcid     = r_read_copy.read();
-#if L1_MULTI_CACHE
-          entry.owner.cache_id  = r_read_copy_cache.read();
-#endif
           entry.owner.inst      = r_read_copy_inst.read();
           entry.count           = r_read_count.read();
@@ -2394,6 +2478,5 @@
         m_cache_directory.write(set, way, entry);
         r_read_fsm    = READ_RSP;
-      }
-      break;
+        break;
     }
     ///////////////////
@@ -2436,6 +2519,4 @@
 
         m_cache_data.read_line(way, set, r_read_data);
-
-        if(m_monitor_ok) check_monitor( m_cmd_read_addr_fifo.read(), r_read_data[0], true);
 
         // update the cache directory
@@ -2452,7 +2533,4 @@
         {
           entry.owner.srcid    = r_read_copy.read();
-#if L1_MULTI_CACHE
-          entry.owner.cache_id = r_read_copy_cache.read();
-#endif
           entry.owner.inst     = r_read_copy_inst.read();
           entry.ptr            = m_heap.next_free_ptr();   // set pointer on the heap
@@ -2461,7 +2539,4 @@
         {
           entry.owner.srcid    = 0;
-#if L1_MULTI_CACHE
-          entry.owner.cache_id = 0;
-#endif
           entry.owner.inst     = false;
           entry.ptr            = 0;
@@ -2529,7 +2604,4 @@
         HeapEntry heap_entry;
         heap_entry.owner.srcid    = m_cmd_read_srcid_fifo.read();
-#if L1_MULTI_CACHE
-        heap_entry.owner.cache_id = m_cmd_read_pktid_fifo.read();
-#endif
         heap_entry.owner.inst     = ((m_cmd_read_pktid_fifo.read() & 0x2) != 0);
 
@@ -2595,7 +2667,4 @@
         HeapEntry last_entry;
         last_entry.owner.srcid    = 0;
-#if L1_MULTI_CACHE
-        last_entry.owner.cache_id = 0;
-#endif
         last_entry.owner.inst     = false;
 
@@ -2718,5 +2787,6 @@
 #if DEBUG_MEMC_READ
 if(m_debug)
-std::cout << "  <MEMC " << name() << " READ_TRT_SET> Write in Transaction Table:"
+          m_trt.print(0);
+std::cout << "  <MEMC " << name() << " READ_TRT_SET> Set a GET in TGT:"
           << " address = " << std::hex << m_cmd_read_addr_fifo.read()
           << " / srcid = " << std::hex << m_cmd_read_srcid_fifo.read() << std::endl;
@@ -2734,6 +2804,6 @@
         cmd_read_fifo_get       = true;
         r_read_to_ixr_cmd_req   = true;
-        r_read_to_ixr_cmd_nline = m_nline[(addr_t)(m_cmd_read_addr_fifo.read())];
-        r_read_to_ixr_cmd_trdid = r_read_trt_index.read();
+        //r_read_to_ixr_cmd_nline = m_nline[(addr_t)(m_cmd_read_addr_fifo.read())];
+        r_read_to_ixr_cmd_index = r_read_trt_index.read();
         r_read_fsm              = READ_IDLE;
 
@@ -2762,7 +2832,6 @@
   //   If the data is cached by other processors, a coherence transaction must
   //   be launched (sc requests always require a coherence transaction):
-  //   It is a multicast update if the line is not in counter mode, and the processor
+  //   It is a multicast update if the line is not in counter mode: the processor
   //   takes the lock protecting the Update Table (UPT) to register this transaction.
-  //   It is a broadcast invalidate if the line is in counter mode.
   //   If the UPT is full, it releases the lock(s) and retry. Then, it sends
   //   a multi-update request to all owners of the line (but the writer),
@@ -2770,9 +2839,12 @@
   //   does not respond to the writing processor, as this response will be sent by
   //   the MULTI_ACK FSM when all update responses have been received.
+  //   It is a broadcast invalidate if the line is in counter mode: The line
+  //   should be erased in memory cache, and written in XRAM with a PUT transaction,
+  //   after registration in TRT.
   //
   // - In case of MISS, the WRITE FSM takes the lock protecting the transaction
   //   table (TRT). If a read transaction to the XRAM for this line already exists,
   //   it writes in the TRT (write buffer). Otherwise, if a TRT entry is free,
-  //   the WRITE FSM register a new transaction in TRT, and sends a read line request
+  //   the WRITE FSM register a new transaction in TRT, and sends a GET request
   //   to the XRAM. If the TRT is full, it releases the lock, and waits.
   //   Finally, the WRITE FSM returns an aknowledge response to the writing processor.
@@ -2849,12 +2921,7 @@
 
         // check that the next word is in the same cache line
-        if((m_nline[(addr_t)(r_write_address.read())]       !=
-            m_nline[(addr_t)(m_cmd_write_addr_fifo.read())]))
-        {
-          std::cout << "VCI_MEM_CACHE ERROR " << name() << " WRITE_NEXT state" << std::endl
-                    << "all words in a write burst must be in same cache line" << std::endl;
-
-          exit(0);
-        }
+        assert( (m_nline[(addr_t)(r_write_address.read())] == 
+               m_nline[(addr_t)(m_cmd_write_addr_fifo.read())]) and
+        "MEMC ERROR in WRITE_NEXT state: Illegal write burst");
 
         // consume a word in the FIFO & write it in the local buffer
@@ -2922,5 +2989,5 @@
         // erase any possible new reservation when we release the lock on the
         // directory
-        m_llsc_table.sw(nline);
+        m_llsc_table.sw(m_nline[(addr_t)r_write_address.read()],r_write_word_index.read(),r_write_word_index.read()+r_write_word_count.read());
 
         //m_llsc_table.sw(r_write_address.read());
@@ -2944,6 +3011,6 @@
     case WRITE_DIR_LOCK:     // access directory to check hit/miss
     {
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE)
-      {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+        "MEMC ERROR in ALLOC_DIR_LOCK state: Bad DIR allocation");
         size_t  way = 0;
         DirectoryEntry entry(m_cache_directory.read(r_write_address.read(), way));
@@ -2956,7 +3023,4 @@
           r_write_tag        = entry.tag;
           r_write_copy       = entry.owner.srcid;
-#if L1_MULTI_CACHE
-          r_write_copy_cache = entry.owner.cache_id;
-#endif
           r_write_copy_inst  = entry.owner.inst;
           r_write_count      = entry.count;
@@ -2970,5 +3034,5 @@
             if(entry.is_cnt && entry.count)
             {
-              r_write_fsm = WRITE_DIR_READ;
+              r_write_fsm = WRITE_BC_DIR_READ;
             }
             else
@@ -3012,13 +3076,4 @@
 }
 #endif
-      }
-      else
-      {
-        std::cout << "VCI_MEM_CACHE ERROR " << name()
-                  << " WRITE_DIR_LOCK state"        << std::endl
-                  << "bad DIR allocation"           << std::endl;
-
-        exit(0);
-      }
       break;
     }
@@ -3076,39 +3131,10 @@
     }
 
-
-    ////////////////////
-    case WRITE_DIR_READ:  // read the cache and complete the buffer when be!=0xF
-    {
-      // update local buffer
-      size_t set  = m_y[(addr_t)(r_write_address.read())];
-      size_t way  = r_write_way.read();
-      for(size_t word=0 ; word<m_words ; word++)
-      {
-        data_t mask = 0;
-        if(r_write_be[word].read() & 0x1) mask = mask | 0x000000FF;
-        if(r_write_be[word].read() & 0x2) mask = mask | 0x0000FF00;
-        if(r_write_be[word].read() & 0x4) mask = mask | 0x00FF0000;
-        if(r_write_be[word].read() & 0x8) mask = mask | 0xFF000000;
-
-        // complete only if mask is not null (for energy consumption)
-        r_write_data[word]  = (r_write_data[word].read() & mask) |
-                              (m_cache_data.read(way, set, word) & ~mask);
-
-      } // end for
-
-      // test if a coherence broadcast is required
-      r_write_fsm = WRITE_BC_TRT_LOCK;
-
-#if DEBUG_MEMC_WRITE
-if(m_debug)
-std::cout << "  <MEMC " << name() << " WRITE_DIR_READ>"
-          << " Read the cache to complete local buffer" << std::endl;
-#endif
-      break;
-    }
-
     ///////////////////
     case WRITE_DIR_HIT:
     {
+      assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+      "MEMC ERROR in ALLOC_DIR_HIT state: Bad DIR allocation");
+ 
       // update the cache directory
       // update directory with Dirty bit
@@ -3121,7 +3147,4 @@
       entry.lock           = r_write_lock.read();
       entry.owner.srcid    = r_write_copy.read();
-#if L1_MULTI_CACHE
-      entry.owner.cache_id = r_write_copy_cache.read();
-#endif
       entry.owner.inst     = r_write_copy_inst.read();
       entry.count          = r_write_count.read();
@@ -3154,9 +3177,4 @@
           m_cache_data.write(way, set, word, r_write_data[word].read(), r_write_be[word].read());
 
-          if(m_monitor_ok)
-          {
-            addr_t address = (r_write_address.read() & ~(addr_t) 0x3F) | word<<2;
-            check_monitor( address, r_write_data[word].read(), false);
-          }
         }
       }
@@ -3242,14 +3260,9 @@
                                r_write_be[word].read());
 
-            if(m_monitor_ok)
-            {
-              addr_t address = (r_write_address.read() & ~(addr_t) 0x3F) | word<<2;
-              check_monitor( address, r_write_data[word].read(), false);
-            }
           }
         }
 
 #if DEBUG_MEMC_WRITE
-if(m_debug)
+if(m_debug and wok)
 {
     if(wok)
@@ -3317,9 +3330,5 @@
       for(size_t i=min ; i<max ; i++) r_write_to_cc_send_data[i] = r_write_data[i];
 
-      if((r_write_copy.read() != r_write_srcid.read()) or(r_write_pktid.read() == TYPE_SC) or
-#if L1_MULTI_CACHE
-          (r_write_copy_cache.read() != r_write_pktid.read()) or
-#endif
-          r_write_copy_inst.read())
+      if((r_write_copy.read() != r_write_srcid.read()) or(r_write_pktid.read() == TYPE_SC) or r_write_copy_inst.read())
       {
         // put the first srcid in the fifo
@@ -3327,7 +3336,4 @@
         write_to_cc_send_fifo_inst    = r_write_copy_inst.read();
         write_to_cc_send_fifo_srcid   = r_write_copy.read();
-#if L1_MULTI_CACHE
-        write_to_cc_send_fifo_cache_id= r_write_copy_cache.read();
-#endif
         if(r_write_count.read() == 1)
         {
@@ -3380,9 +3386,5 @@
       bool dec_upt_counter;
 
-      if(((entry.owner.srcid != r_write_srcid.read()) or (r_write_pktid.read() == TYPE_SC)) or
-#if L1_MULTI_CACHE
-          (entry.owner.cache_id != r_write_pktid.read()) or
-#endif
-          entry.owner.inst)             // put the next srcid in the fifo
+      if(((entry.owner.srcid != r_write_srcid.read()) or (r_write_pktid.read() == TYPE_SC)) or entry.owner.inst)             // put the next srcid in the fifo
       {
         dec_upt_counter                = false;
@@ -3390,7 +3392,4 @@
         write_to_cc_send_fifo_inst     = entry.owner.inst;
         write_to_cc_send_fifo_srcid    = entry.owner.srcid;
-#if L1_MULTI_CACHE
-        write_to_cc_send_fifo_cache_id = entry.owner.cache_id;
-#endif
 
 #if DEBUG_MEMC_WRITE
@@ -3573,5 +3572,5 @@
         bool    hit_read  = m_trt.hit_read(m_nline[addr], hit_index);
         bool    hit_write = m_trt.hit_write(m_nline[addr]);
-        bool    wok       = !m_trt.full(wok_index);
+        bool    wok       = not m_trt.full(wok_index);
         //std::cout << "MEMCACHE : WRITE MISS at " << std::hex << (uint32_t)addr << std::dec << std::endl;
         if(hit_read)      // register the modified data in TRT
@@ -3641,4 +3640,5 @@
 #if DEBUG_MEMC_WRITE
 if(m_debug)
+        m_trt.print(0);
 std::cout << "  <MEMC " << name() << " WRITE_MISS_TRT_SET> Set a new entry in TRT" << std::endl;
 #endif
@@ -3662,6 +3662,6 @@
         }
         m_trt.write_data_mask(r_write_trt_index.read(),
-                                          be_vector,
-                                          data_vector);
+                              be_vector,
+                              data_vector);
         r_write_fsm = WRITE_RSP;
 
@@ -3677,10 +3677,9 @@
     case WRITE_MISS_XRAM_REQ: // send a GET request to IXR_CMD FSM
     {
-      if(!r_write_to_ixr_cmd_req)
+      if(not r_write_to_ixr_cmd_req.read())
       {
         r_write_to_ixr_cmd_req   = true;
-        r_write_to_ixr_cmd_write = false;
-        r_write_to_ixr_cmd_nline = m_nline[(addr_t)(r_write_address.read())];
-        r_write_to_ixr_cmd_trdid = r_write_trt_index.read();
+        r_write_to_ixr_cmd_put   = false;
+        r_write_to_ixr_cmd_index = r_write_trt_index.read();
         r_write_fsm              = WRITE_RSP;
 
@@ -3694,10 +3693,47 @@
 
     ///////////////////////
-    case WRITE_BC_TRT_LOCK:     // Check TRT not full
-    {
+    case WRITE_BC_DIR_READ:  // enter this state if a broadcast-inval is required
+                             // the cache line must be erased in mem-cache, and written
+                             // into XRAM. we read the cache and complete the buffer
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+        "MEMC ERROR in WRITE_BC_DIR_READ state: Bad DIR allocation");
+ 
+        // update local buffer
+        size_t set  = m_y[(addr_t)(r_write_address.read())];
+        size_t way  = r_write_way.read();
+        for(size_t word=0 ; word<m_words ; word++)
+        {
+            data_t mask = 0;
+            if(r_write_be[word].read() & 0x1) mask = mask | 0x000000FF;
+            if(r_write_be[word].read() & 0x2) mask = mask | 0x0000FF00;
+            if(r_write_be[word].read() & 0x4) mask = mask | 0x00FF0000;
+            if(r_write_be[word].read() & 0x8) mask = mask | 0xFF000000;
+
+            // complete only if mask is not null (for energy consumption)
+            r_write_data[word]  = (r_write_data[word].read() & mask) |
+                                  (m_cache_data.read(way, set, word) & ~mask);
+        } // end for
+
+        r_write_fsm = WRITE_BC_TRT_LOCK;
+
+#if DEBUG_MEMC_WRITE
+if(m_debug)
+std::cout << "  <MEMC " << name() << " WRITE_BC_DIR_READ>"
+          << " Read the cache to complete local buffer" << std::endl;
+#endif
+        break;
+    }
+
+    ///////////////////////
+    case WRITE_BC_TRT_LOCK:     // get TRT lock to check TRT not full
+    {
+      assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+      "MEMC ERROR in WRITE_BC_TRT_LOCK state: Bad DIR allocation");
+
       if(r_alloc_trt_fsm.read() == ALLOC_TRT_WRITE)
       {
         size_t wok_index = 0;
-        bool wok = !m_trt.full(wok_index);
+        bool wok = not m_trt.full(wok_index);
         if(wok)       // set a new entry in TRT
         {
@@ -3726,4 +3762,10 @@
     case WRITE_BC_IVT_LOCK:      // register BC transaction in IVT
     {
+      assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+      "MEMC ERROR in WRITE_BC_IVT_LOCK state: Bad DIR allocation");
+
+      assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_WRITE) and
+      "MEMC ERROR in WRITE_BC_IVT_LOCK state: Bad TRT allocation");
+
       if(r_alloc_ivt_fsm.read() == ALLOC_IVT_WRITE)
       {
@@ -3767,27 +3809,28 @@
     case WRITE_BC_DIR_INVAL:
     {
-      // Register a put transaction to XRAM in TRT
-      // and invalidate the line in directory
-      if((r_alloc_trt_fsm.read() != ALLOC_TRT_WRITE) or
-         (r_alloc_ivt_fsm.read() != ALLOC_IVT_WRITE) or
-         (r_alloc_dir_fsm.read() != ALLOC_DIR_WRITE))
-      {
-        std::cout << "VCI_MEM_CACHE ERROR " << name() << " WRITE_BC_DIR_INVAL state" << std::endl;
-        std::cout << "bad TRT, DIR, or IVT allocation" << std::endl;
-        exit(0);
-      }
-
-      // register a write request to XRAM in TRT
-      m_trt.set(r_write_trt_index.read(),
-                            false,    // write request to XRAM
-                            m_nline[(addr_t)(r_write_address.read())],
-                            0,
-                            0,
-                            0,
-                            false,    // not a processor read
-                            0,        // not a single word
-                            0,            // word index
-                            std::vector<be_t> (m_words,0),
-                            std::vector<data_t> (m_words,0));
+      assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+      "MEMC ERROR in WRITE_BC_DIR_INVAL state: Bad DIR allocation");
+
+      assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_WRITE) and
+      "MEMC ERROR in WRITE_BC_DIR_INVAL state: Bad TRT allocation");
+ 
+      assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_WRITE) and
+      "MEMC ERROR in WRITE_BC_DIR_INVAL state: Bad IVT allocation");
+
+      // register PUT request in TRT
+      std::vector<data_t> data_vector;
+      data_vector.clear();
+      for(size_t i=0; i<m_words; i++) data_vector.push_back(r_write_data[i].read());
+      m_trt.set( r_write_trt_index.read(),
+                 false,             // PUT request
+                 m_nline[(addr_t)(r_write_address.read())],
+                 0,                 // unused
+                 0,                 // unused
+                 0,                 // unused
+                 false,             // not a processor read
+                 0,                 // unused
+                 0,                 // unused
+                 std::vector<be_t> (m_words,0),
+                 data_vector );
 
       // invalidate directory entry
@@ -3796,11 +3839,8 @@
       entry.cache_coherent= false;
       entry.dirty         = false;
-      entry.tag         = 0;
+      entry.tag           = 0;
       entry.is_cnt        = false;
       entry.lock          = false;
       entry.owner.srcid   = 0;
-#if L1_MULTI_CACHE
-      entry.owner.cache_id= 0;
-#endif
       entry.owner.inst    = false;
       entry.ptr           = 0;
@@ -3813,4 +3853,5 @@
 #if DEBUG_MEMC_WRITE
 if(m_debug)
+          m_trt.print(0);
 std::cout << "  <MEMC " << name() << " WRITE_BC_DIR_INVAL> Invalidate the directory entry: @ = "
           << r_write_address.read() << " / register the put transaction in TRT:" << std::endl;
@@ -3851,13 +3892,9 @@
     case WRITE_BC_XRAM_REQ:   // Post a put request to IXR_CMD FSM
     {
-      if(!r_write_to_ixr_cmd_req)
+      if( not r_write_to_ixr_cmd_req.read() )
       {
         r_write_to_ixr_cmd_req     = true;
-        r_write_to_ixr_cmd_write   = true;
-        r_write_to_ixr_cmd_nline   = m_nline[(addr_t)(r_write_address.read())];
-        r_write_to_ixr_cmd_trdid   = r_write_trt_index.read();
-
-        for(size_t i=0; i<m_words; i++) r_write_to_ixr_cmd_data[i] = r_write_data[i];
-
+        r_write_to_ixr_cmd_put     = true;
+        r_write_to_ixr_cmd_index   = r_write_trt_index.read();
         r_write_fsm = WRITE_IDLE;
 
@@ -3876,16 +3913,19 @@
   ///////////////////////////////////////////////////////////////////////
   // The IXR_CMD fsm controls the command packets to the XRAM :
-  // It handles requests from the READ, WRITE, CAS, XRAM_RSP FSMs
-  // with a round-robin priority.
+  // It handles requests from 5 FSMs with a round-robin priority:
+  //  READ > WRITE > CAS > XRAM_RSP > CONFIG
   //
-  // - It sends a single flit VCI read request to the XRAM in case of MISS
-  // posted by the READ, WRITE or CAS FSMs : the TRDID field contains
-  // the Transaction Tab index.
-  // The VCI response is a multi-flit packet : the N cells contain
-  // the N data words.
+  // - It sends a single flit VCI read to the XRAM in case of
+  //   GET request posted by the READ, WRITE or CAS FSMs. 
+  // - It sends a multi-flit VCI write in case of PUT request posted by
+  //   the XRAM_RSP, WRITE, CAS, or CONFIG FSMs.
   //
-  // - It sends a multi-flit VCI write when the XRAM_RSP FSM, WRITE FSM
-  // or CAS FSM request to save a dirty line to the XRAM.
-  // The VCI response is a single flit packet.
+  // For each client, there is three steps:
+  // - IXR_CMD_*_IDLE : round-robin allocation to a client
+  // - IXR_CMD_*_TRT  : access to TRT for address and data
+  // - IXR_CMD_*_SEND : send the PUT or GET VCI command
+  //
+  // The address and data to be written (for a PUT) are stored in TRT.
+  // The trdid field contains always the TRT entry index.
   ////////////////////////////////////////////////////////////////////////
 
